/*******************************************************************************
 * (c) Copyright 2008 Actel Corporation.  All rights reserved.
 * 
 * CoreSPI hardware registers definitions.
 *
 * SVN $Revision: 1549 $
 * SVN $Date: 2009-10-22 15:11:24 +0100 (Thu, 22 Oct 2009) $
 */
#ifndef CORESPI_REGS_H_
#define CORESPI_REGS_H_

/*******************************************************************************
 * DATA register:
 *------------------------------------------------------------------------------
 */
#define DATA_REG_OFFSET	0x00

/*******************************************************************************
 * CTRL1 register:
 *------------------------------------------------------------------------------
 */
#define CTRL1_REG_OFFSET	0x04

/*------------------------------------------------------------------------------
 * SCKS:
 *   Serial clock divider.
 *------------------------------------------------------------------------------
 */
#define SCKS_BIT_OFFSET   0x04

/* #define SCKS_BIT_MASK  0x03 */
/* JMG - changed clock mask */
#define SCKS_BIT_MASK     0x07
#define SCKS_BIT_SHIFT    0

/*------------------------------------------------------------------------------
 * CPOL:
 *   Clock polarity.
 *------------------------------------------------------------------------------
 */
#define CPOL_BIT_OFFSET   0x04
#define CPOL_BIT_MASK     0x08
#define CPOL_BIT_SHIFT    3

/*------------------------------------------------------------------------------
 * CPHA:
 *   Clock phase.
 *------------------------------------------------------------------------------
 */
#define CPHA_BIT_OFFSET   0x04
#define CPHA_BIT_MASK     0x10
#define CPHA_BIT_SHIFT    4

/*------------------------------------------------------------------------------
 * ORDER:
 *   Order of transfer.
 *------------------------------------------------------------------------------
 */
#define ORDER_BIT_OFFSET   0x04
#define ORDER_BIT_MASK     0x20
#define ORDER_BIT_SHIFT    5

/*------------------------------------------------------------------------------
 * MODE:
 *   Master/Slave mode select.
 *------------------------------------------------------------------------------
 */
#define MODE_BIT_OFFSET   0x04
#define MODE_BIT_MASK     0x40
#define MODE_BIT_SHIFT    6

/*------------------------------------------------------------------------------
 * CTRL1_IE:
 *   Interrupt enable.
 *------------------------------------------------------------------------------
 */
#define CTRL1_IE_BIT_OFFSET   0x04
#define CTRL1_IE_BIT_MASK     0x80
#define CTRL1_IE_BIT_SHIFT    7

/*******************************************************************************
 * CTRL2 register:
 *------------------------------------------------------------------------------
 */
#define CTRL2_REG_OFFSET	0x08

/*------------------------------------------------------------------------------
 * ENABLE:
 *   SPI enable bit.
 *------------------------------------------------------------------------------
 */
#define CTRL2_EN_BIT_OFFSET   0x08
#define CTRL2_EN_BIT_MASK     0x80
#define CTRL2_EN_BIT_SHIFT    7

/*------------------------------------------------------------------------------
 * ERROR:
 *   Error bit.
 *------------------------------------------------------------------------------
 */
#define ERROR_BIT_OFFSET   0x08
#define ERROR_BIT_MASK     0x01
#define ERROR_BIT_SHIFT    0

/*******************************************************************************
 * STATUS register:
 *------------------------------------------------------------------------------
 */
#define STATUS_REG_OFFSET	0x08

/*------------------------------------------------------------------------------
 * RX_DATA_RDY:
 *   Rx data ready.
 *------------------------------------------------------------------------------
 */
#define STATUS_RX_DATA_RDY_BIT_OFFSET   0x08
#define STATUS_RX_DATA_RDY_BIT_MASK     0x02
#define STATUS_RX_DATA_RDY_BIT_SHIFT    1

/*------------------------------------------------------------------------------
 * TX_EMPTY:
 *   Tx register empty.
 *------------------------------------------------------------------------------
 */
#define STATUS_TX_EMPTY_BIT_OFFSET   0x08
#define STATUS_TX_EMPTY_BIT_MASK     0x04
#define STATUS_TX_EMPTY_BIT_SHIFT    2

/*------------------------------------------------------------------------------
 * BUSY:
 *   Master busy.
 *------------------------------------------------------------------------------
 */
#define STATUS_BUSY_BIT_OFFSET   0x08
#define STATUS_BUSY_BIT_MASK     0x08
#define STATUS_BUSY_BIT_SHIFT    3

/*******************************************************************************
 *  register:
 *------------------------------------------------------------------------------
 */
#define SLAVE_SEL_REG_OFFSET	0x0C

#endif /*CORESPI_REGS_H_*/
